commit:     0cbedddea510010caa0597b963d8add093ef7c71
Author:     Andreas K. Hüttel <dilfridge <AT> gentoo <DOT> org>
AuthorDate: Sat Oct 28 20:50:22 2017 +0000
Commit:     Andreas Hüttel <dilfridge <AT> gentoo <DOT> org>
CommitDate: Sat Oct 28 20:50:30 2017 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=0cbeddde

media-libs/mlt: Add glibc-2.26 compatibility patches.

Revision bump since headers have to be modified.

Closes: https://bugs.gentoo.org/635088
Package-Manager: Portage-2.3.13, Repoman-2.3.4

 media-libs/mlt/files/mlt-6.4.1-glibc226-1.patch |  40 +++++
 media-libs/mlt/files/mlt-6.4.1-glibc226-2.patch |  22 +++
 media-libs/mlt/mlt-6.4.1-r4.ebuild              | 224 ++++++++++++++++++++++++
 3 files changed, 286 insertions(+)

diff --git a/media-libs/mlt/files/mlt-6.4.1-glibc226-1.patch 
b/media-libs/mlt/files/mlt-6.4.1-glibc226-1.patch
new file mode 100644
index 00000000000..2f486939d8f
--- /dev/null
+++ b/media-libs/mlt/files/mlt-6.4.1-glibc226-1.patch
@@ -0,0 +1,40 @@
+From 2125e3955a0d0be61571cf43b674f74b4b93c6f8 Mon Sep 17 00:00:00 2001
+From: Dan Dennedy <d...@dennedy.org>
+Date: Sat, 26 Aug 2017 18:31:47 -0700
+Subject: [PATCH] Fix #248 xlocale.h was removed in glibc 2.26.
+MIME-Version: 1.0
+Content-Type: text/plain; charset=UTF-8
+Content-Transfer-Encoding: 8bit
+
+Reported by schnitzeltony on Andreas Müller.
+Patch by Dave Plater.
+---
+ src/framework/mlt_property.h | 8 ++++++--
+ 1 file changed, 6 insertions(+), 2 deletions(-)
+
+diff --git a/src/framework/mlt_property.h b/src/framework/mlt_property.h
+index 404d513f..043f530b 100644
+--- a/src/framework/mlt_property.h
++++ b/src/framework/mlt_property.h
+@@ -3,7 +3,7 @@
+  * \brief Property class declaration
+  * \see mlt_property_s
+  *
+- * Copyright (C) 2003-2014 Meltytech, LLC
++ * Copyright (C) 2003-2017 Meltytech, LLC
+  *
+  * This library is free software; you can redistribute it and/or
+  * modify it under the terms of the GNU Lesser General Public
+@@ -31,7 +31,11 @@
+ #endif
+ 
+ #if defined(__GLIBC__) || defined(__APPLE__) || (__FreeBSD_version >= 900506)
+-#include <xlocale.h>
++#  if GLIBC_MINOR >= 26 && !defined(APPLE)
++#    include <locale.h>
++#  else
++#    include <xlocale.h>
++#  endif
+ #else
+ typedef char* locale_t;
+ #endif

diff --git a/media-libs/mlt/files/mlt-6.4.1-glibc226-2.patch 
b/media-libs/mlt/files/mlt-6.4.1-glibc226-2.patch
new file mode 100644
index 00000000000..d992ee32e06
--- /dev/null
+++ b/media-libs/mlt/files/mlt-6.4.1-glibc226-2.patch
@@ -0,0 +1,22 @@
+From fbf6a5187776f2f392cf258935ff49e4c0e87024 Mon Sep 17 00:00:00 2001
+From: Dan Dennedy <d...@dennedy.org>
+Date: Wed, 30 Aug 2017 09:08:16 -0700
+Subject: [PATCH] Fix glib test macros to include locale.h.
+
+---
+ src/framework/mlt_property.h | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/framework/mlt_property.h b/src/framework/mlt_property.h
+index 043f530b..3ecebd67 100644
+--- a/src/framework/mlt_property.h
++++ b/src/framework/mlt_property.h
+@@ -31,7 +31,7 @@
+ #endif
+ 
+ #if defined(__GLIBC__) || defined(__APPLE__) || (__FreeBSD_version >= 900506)
+-#  if GLIBC_MINOR >= 26 && !defined(APPLE)
++#  if __GLIBC_MINOR__ >= 26 && !defined(__APPLE__)
+ #    include <locale.h>
+ #  else
+ #    include <xlocale.h>

diff --git a/media-libs/mlt/mlt-6.4.1-r4.ebuild 
b/media-libs/mlt/mlt-6.4.1-r4.ebuild
new file mode 100644
index 00000000000..f644ac3bb1f
--- /dev/null
+++ b/media-libs/mlt/mlt-6.4.1-r4.ebuild
@@ -0,0 +1,224 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+PYTHON_COMPAT=( python2_7 )
+# this ebuild currently only supports installing ruby bindings for a single 
ruby version
+# so USE_RUBY must contain only a single value (the latest stable) as the 
ebuild calls
+# /usr/bin/${USE_RUBY} directly
+USE_RUBY="ruby22"
+inherit eutils flag-o-matic multilib python-single-r1 ruby-single 
toolchain-funcs
+
+DESCRIPTION="Open source multimedia framework for television broadcasting"
+HOMEPAGE="https://www.mltframework.org/";
+SRC_URI="https://github.com/mltframework/${PN}/archive/v${PV}.tar.gz -> 
${P}.tar.gz"
+
+LICENSE="GPL-3"
+SLOT="0"
+KEYWORDS="~amd64 ~x86 ~x86-fbsd ~amd64-linux ~x86-linux"
+IUSE="compressed-lumas cpu_flags_x86_mmx cpu_flags_x86_sse cpu_flags_x86_sse2 
debug ffmpeg fftw frei0r
+gtk jack kdenlive libav libsamplerate lua melt opencv opengl python qt5 
rtaudio ruby sdl vdpau xine xml"
+# java perl php tcl vidstab
+IUSE="${IUSE} kernel_linux"
+
+REQUIRED_USE="python? ( ${PYTHON_REQUIRED_USE} )"
+
+#rtaudio will use OSS on non linux OSes
+COMMON_DEPEND="
+       >=media-libs/libebur128-1.2.2
+       ffmpeg? (
+               libav? ( media-video/libav:0=[vdpau?] )
+               !libav? ( media-video/ffmpeg:0=[vdpau?] )
+       )
+       fftw? ( sci-libs/fftw:3.0= )
+       frei0r? ( media-plugins/frei0r-plugins )
+       gtk? (
+               media-libs/libexif
+               x11-libs/gtk+:2
+               x11-libs/pango
+       )
+       jack? (
+               >=dev-libs/libxml2-2.5
+               media-libs/ladspa-sdk
+               >=media-sound/jack-audio-connection-kit-0.121.3
+       )
+       libsamplerate? ( >=media-libs/libsamplerate-0.1.2 )
+       lua? ( >=dev-lang/lua-5.1.4-r4:= )
+       opencv? ( >=media-libs/opencv-3.1.0:= )
+       opengl? ( media-video/movit )
+       python? ( ${PYTHON_DEPS} )
+       qt5? (
+               dev-qt/qtcore:5
+               dev-qt/qtgui:5
+               dev-qt/qtsvg:5
+               dev-qt/qtwidgets:5
+               dev-qt/qtxml:5
+               media-libs/libexif
+               x11-libs/libX11
+               opengl? ( dev-qt/qtopengl:5 )
+       )
+       rtaudio? (
+               media-libs/rtaudio
+               kernel_linux? ( media-libs/alsa-lib )
+       )
+       ruby? ( ${RUBY_DEPS} )
+       sdl? (
+               >=media-libs/libsdl-1.2.10[X,opengl,video]
+               >=media-libs/sdl-image-1.2.4
+       )
+       xine? ( >=media-libs/xine-lib-1.1.2_pre20060328-r7 )
+       xml? ( >=dev-libs/libxml2-2.5 )"
+#      java? ( >=virtual/jre-1.5 )
+#      perl? ( dev-lang/perl )
+#      php? ( dev-lang/php )
+#      sox? ( media-sound/sox )
+#      tcl? ( dev-lang/tcl:0= )
+#      vidstab? ( media-libs/libvidstab )
+SWIG_DEPEND=">=dev-lang/swig-2.0"
+DEPEND="${COMMON_DEPEND}
+       virtual/pkgconfig
+       compressed-lumas? ( virtual/imagemagick-tools[png] )
+       lua? ( ${SWIG_DEPEND} virtual/pkgconfig )
+       python? ( ${SWIG_DEPEND} )
+       ruby? ( ${SWIG_DEPEND} )"
+#      java? ( ${SWIG_DEPEND} >=virtual/jdk-1.5 )
+#      perl? ( ${SWIG_DEPEND} )
+#      php? ( ${SWIG_DEPEND} )
+#      tcl? ( ${SWIG_DEPEND} )
+RDEPEND="${COMMON_DEPEND}
+       !media-libs/mlt++
+"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-6.2.0-ruby-link.patch
+       "${FILESDIR}"/${P}-libebur128-unbundle.patch
+       "${FILESDIR}"/${P}-opencv-3.3.patch
+       "${FILESDIR}"/${P}-glibc226-1.patch
+       "${FILESDIR}"/${P}-glibc226-2.patch
+)
+
+pkg_setup() {
+       use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+       default
+
+       # respect CFLAGS LDFLAGS when building shared libraries. Bug #308873
+       for x in python lua; do
+               sed -i "/mlt.so/s: -lmlt++ :& ${CFLAGS} ${LDFLAGS} :" 
src/swig/$x/build || die
+       done
+       sed -i "/^LDFLAGS/s: += :& ${LDFLAGS} :" src/swig/ruby/build || die
+
+       sed -i -e "s/env ruby/${USE_RUBY}/" src/swig/ruby/* || die
+}
+
+src_configure() {
+       tc-export CC CXX
+
+       # bug 589848
+       append-cxxflags -std=c++11
+
+       local myconf="--enable-gpl
+               --enable-gpl3
+               --enable-motion-est
+               --target-arch=$(tc-arch)
+               --disable-kde
+               --disable-swfdec
+               $(use_enable debug)
+               $(use compressed-lumas && echo ' --luma-compress')
+               $(use_enable cpu_flags_x86_sse sse)
+               $(use_enable cpu_flags_x86_sse2 sse2)
+               $(use_enable gtk gtk2)
+               $(use_enable sdl)
+               $(use_enable jack jackrack)
+               $(use_enable ffmpeg avformat)
+               $(use ffmpeg && echo ' --avformat-swscale')
+               $(use_enable fftw plus)
+               $(use_enable frei0r)
+               $(use_enable melt)
+               $(use_enable opencv)
+               $(use_enable opengl)
+               $(use_enable libsamplerate resample)
+               $(use_enable rtaudio)
+               $(use vdpau && echo ' --avformat-vdpau')
+               $(use_enable xml)
+               $(use_enable xine)
+               $(use_enable kdenlive)
+               --disable-sox"
+               #$(use_enable sox) FIXME
+
+       if use qt5 ; then
+               myconf+=" --enable-qt
+                       --qt-includedir=$(pkg-config Qt5Core 
--variable=includedir)
+                       --qt-libdir=$(pkg-config Qt5Core --variable=libdir)"
+       else
+               myconf+=" --disable-qt"
+       fi
+
+       if use x86 || use amd64 ; then
+               myconf+=" $(use_enable cpu_flags_x86_mmx mmx)"
+       else
+               myconf+=" --disable-mmx"
+       fi
+
+       if ! use melt; then
+               sed -i -e "s;src/melt;;" Makefile || die
+       fi
+
+       # TODO: add swig language bindings
+       # see also 
https://www.mltframework.org/twiki/bin/view/MLT/ExtremeMakeover
+
+       local swig_lang
+       # TODO: java perl php tcl
+       for i in lua python ruby ; do
+               use $i && swig_lang="${swig_lang} $i"
+       done
+       [ -z "${swig_lang}" ] && swig_lang="none"
+
+       econf ${myconf} --swig-languages="${swig_lang}"
+
+       sed -i -e s/^OPT/#OPT/ "${S}/config.mak" || die
+       if use qt5 ; then
+               if ! use opengl ; then
+                       sed -i -e "/^USE_QT_OPENGL/ s/^/#/" 
"${S}/src/modules/qt/config.mak" || die
+               fi
+       fi
+}
+
+src_install() {
+       emake DESTDIR="${D}" install
+       dodoc AUTHORS ChangeLog NEWS README docs/*.txt
+
+       dodir /usr/share/${PN}
+       insinto /usr/share/${PN}
+       doins -r demo
+
+       docinto swig
+
+       # Install SWIG bindings
+       if use lua; then
+               cd "${S}"/src/swig/lua || die
+               exeinto $(pkg-config --variable INSTALL_CMOD lua)
+               doexe mlt.so
+               dodoc play.lua
+       fi
+
+       if use python; then
+               cd "${S}"/src/swig/python || die
+               insinto $(python_get_sitedir)
+               doins mlt.py
+               exeinto $(python_get_sitedir)
+               doexe _mlt.so
+               dodoc play.py
+               python_optimize
+       fi
+
+       if use ruby; then
+               cd "${S}"/src/swig/ruby || die
+               exeinto $("${EPREFIX}"/usr/bin/${USE_RUBY} -r rbconfig -e 
'print RbConfig::CONFIG["sitearchdir"]')
+               doexe mlt.so
+               dodoc play.rb thumbs.rb
+       fi
+       # TODO: java perl php tcl
+}

Reply via email to